program XPATH;  {               Version 1.1                          88/12/05

   Author:  Mike Babulic              Compuserve: 72307,314
            3827 Charleswood Dr. N.W.
            Calgary, Alberta
            CANADA
            T2L 2C7

History:

   88/12/01 - Version 1.0

   88/12/05 - Version 1.1 - Mike Babulic - Warning message if the user tries
      to use the Standard Path without having set one.
}

  uses Dos,CRT,EnvUnit;

  const
       StdExt  = '.STD';

       Push    = '+';
       Pop     = '-';
       Add     = '++';
       Del     = '--';
       Std     = '=';
       UsePath = '==';

  var
       thePath : string;

 procedure Strip(c:char;var s:string);
   var i : integer;
   begin
     i := length(s);
     while (s[i]=c) and (i>0) do dec(i);
     s[0] := chr(i);
   end;

 procedure ChangePath(s:string);
   begin
     if SetPath(s) then;
   end;

 procedure PushPath(NewPath: string);
   begin
     Strip(';',NewPath);
     if NewPath<>'' then
       ChangePath(NewPath+';'+FirstNamed('PATH',#0));
   end;

 procedure PopPath(NewPath: string);
   var aPath,thePath : string;
   procedure BuildPath;
     begin
       thePath := NextNamed;
       While not EONamed do
         thePath := thePath + ';' + NextNamed;
       ChangePath(thePath);
     end;
   begin
     Strip(';',NewPath);
     aPath := FirstNamed('PATH',';');
     thePath :='';
     if NewPath='' then
       BuildPath
     else begin
       NewPath := UpperStr(NewPath);
       while (NewPath<>aPath) and not EONamed do
         aPath := NextNamed;
       if NewPath=aPath then
         BuildPath;
     end;
   end;

 procedure AddPath(NewPath: string);
   begin
     Strip(';',NewPath);
     if NewPath<>'' then
       ChangePath(FirstNamed('PATH',#0) +';'+ NewPath);
   end;

 procedure DelPath(NewPath: string);
   var aPath,thePath : string;
   begin
     Strip(';',NewPath);
     NewPath := UpperStr(NewPath);
     aPath := FirstNamed('PATH',';');
     while (NewPath=aPath) and not EONamed do
       aPath := NextNamed;
     thePath := '';
     if NewPath<>aPath then begin
       thePath := aPath;
       while not EONamed do begin
         aPath := NextNamed;
         if NewPath<>aPath then
           thePath := thePath + ';' + aPath;
       end;
     end;
     ChangePath(thePath);
   end;


 var StdDir  : DirStr;
     Stdpath : String;
     StdF : Text;
     StdFound : Boolean;

 procedure GetStd;
   begin
     if Dos_Version<300 then begin
       MyName := 'XPATH';
       MyExt  := '.EXE';
     end;
     StdDir := PathTo(MyName+StdExt);
     StdFound := (StdDir<>'');
     if not StdFound then
       if Dos_Version<300 then begin
         StdDir := PathTo(MyName+MyExt);
         StdFound := (StdDir<>'');
         if not StdFound then
           StdDir := FExpand('\')
        end
       else
         StdDir := MyDir;
     Assign(StdF,StdDir+MyName+StdExt);
     if FileExists(StdDir+MyName+StdExt) then begin
       Reset(StdF);
       Readln(StdF,StdPath);
       Close(StdF);
      end
     else
       StdPath := FirstNamed('PATH',#0);
   end;

 procedure SetStd(NewPath: string);
   begin
     GetStd;
     Rewrite(StdF);
     Strip(';',NewPath);
     Writeln(StdF,UpperStr(NewPath));
     Close(StdF);
   end;

 procedure UseStdPath(NewPath: string);
   begin
     GetStd;
     if StdFound then begin
       Strip(';',NewPath);
       if NewPath='' then
         ChangePath(StdPath)
       else
         ChangePath(NewPath+';'+StdPath);
      end
     else begin
       writeln;
       writeln('No Standard Path was found.');
       writeln('   You must use the "=" or "==" option to create one.');
       writeln('   Read the XPATH.DOC file for more information.');
       writeln;
       sound(880); delay(300); NoSound;
     end;
   end;



  var cmd,dir : string;
  begin
    cmd := paramstr(1); dir := paramstr(2);
    UseRootPSP;
    if Push = ParamStr(1) then PushPath(ParamStr(2)) else
    if Pop  = ParamStr(1) then PopPath(ParamStr(2)) else
    if Add  = ParamStr(1) then AddPath(ParamStr(2)) else
    if Del  = ParamStr(1) then DelPath(ParamStr(2)) else
    if Std  = ParamStr(1) then SetStd(ParamStr(2))  else
    if UsePath = ParamStr(1) then SetStd(FirstNamed('PATH',#0))
    else
             UseStdPath(ParamStr(1));
  end.